#
#
# Tutos Database selection support
#
# $Header: /cvsroot/tutos/tutos/shellfunc.sh,v 1.18 2003/04/22 09:35:42 tapoueh Exp $
# 
# A note about passwords:
# -----------------------
# the hardcoded password here were generated by using the cryptpw programm
# cryptpw guest 271166     -> 27KsYMdWyc8As
# cryptpw tutos 271166     -> 279dx4Vrn7sgw
#
# if your OS does not support crypt please change the settings in
#  [tutosdir]/config.pinc
# and change the GUESTPW and SUPERPW here to clear unencrypted text
# same is true for the servlet version
#
#  GUESTPW="'guest'" ; export GUESTPW
#  SUPERPW="'tutos'" ; export SUPERPW
#
#  Dont forget do comment out the passwords in the script below.
#
# The MySQL Password settings should not be changed !
#
setdb() {
    # in case of a debian package installation, the informations will be
    # found in the environment
    if [ -n $db_host ]; then
    	DBPORT=$db_port
	DBHOST=$db_host
	DBUSER=$dbu_name
	DBUPASS=$dbu_password
	DBSUSER=$dba_name
	DBPASSWD=$dba_password
    else
        # support for debian
	if [ -f /etc/debian_version ]; then
            # debian system
	    DBUSER=$dbu_name
	    DBSUSER=$dba_name
	    DBPASSWD="$dba_password"
	else
	    # other one
	    DBUSER=wwwrun
	    DBSUSER=root
	    DBPASSWD=""
	fi
	DBHOST=localhost
    fi

  # compare this to [tutosdir]/php/config.pinc
  APACHEHOST=localhost
  DBNAME=tutos

  if [ $1 = "ORACLE" ]
  then
    DBTYPE=3;
    DBSUSER=system
    DBNAME=TDB
    DBPASSWD=tutos
    SQLCMD="sqlplus"
    carg1="-s ${DBUSER}/${DBPASSWD}@${DBNAME}"
    line1="spool $1.log"
    line2="ALTER SESSION SET NLS_DATE_FORMAT = 'YYYY-MM-DD HH24:MI:SS';";
    # Passwort for Guestaccount this is guest encrypted 271166
    GUESTPW="'27KsYMdWyc8As'"
    SUPERPW="'279dx4Vrn7sgw'"
  fi
  if [ $1 = "POSTGRES" ]
  then
    DBTYPE=1;
    DBPORT="5432"
    PATH=$PATH:.:~postgres/bin
    SQLCMD="psql -q "
    carg1=$DBNAME
    line1="\connect $DBNAME $DBUSER"
    line2=""
    # Passwort for Guestaccount this is guest encrypted 271166
    GUESTPW="'27KsYMdWyc8As'"
    SUPERPW="'279dx4Vrn7sgw'"
  fi
  if [ $1 = "MYSQL" ]
  then
    DBTYPE=2;
    SQLCMD="mysql"
    # 
    if [ "$DBPASSWD" = "" ]
    then
     carg1="-v -f -u$DBUSER -h $DBHOST $DBNAME "
    else
     carg1="-v -f -u$DBUSER -p$DBPASSWD -h $DBHOST $DBNAME "
    fi
    line1=""
    line2=""
    # Passwort for Guestaccount MYSQL does its own encryption
    GUESTPW="PASSWORD('guest')"
    SUPERPW="PASSWORD('tutos')"
  fi

  if [ $1 = "INTERBASE" ]
  then
    DBSUSER=SYSDBA
    DBPASSWD="tutos"
    DBNAME=/tmp/tutos.gdb

    DBTYPE=7;
    SQLCMD="isql"
    carg1="-u $DBUSER -p $DBPASSWD $DBHOST:$DBNAME "
    # 
    line1=""
    line2=""
    # Passwort for Guestaccount MYSQL does its own encryption
    GUESTPW="PASSWORD('guest')"
    SUPERPW="PASSWORD('tutos')"
  fi

  # Now Export everything
  export DBTYPE
  export PATH
  export APACHEHOST
  export DBHOST
  export DBUSER
  export DBUPASS
  export DBSUSER
  export DBPASSWD
  export DBNAME
  export DBPORT
  export GUESTPW
  export SUPERPW

  export SQLCMD
  export carg1
  export line1
  export line2
  export droparg
  export dropsequence
  export createsequence
}

notice() {
  echo "----------------------------------------------------------------"
  echo "When using the PHP version of TUTOS please"
  echo "ensure that your php/config.pinc files has the following entries"
  echo ""
  echo "\$tutos[dbname][0]     = \"$DBNAME\";"
  echo "\$tutos[dbhost][0]     = \"$DBHOST\";"
  echo "\$tutos[dbuser][0]     = \"$DBUSER\";"
  echo "\$tutos[dbpasswd][0]   = \"$DBPASSWD\";"
  echo "\$tutos[dbtype][0]     = $DBTYPE ;"
  echo "\$tutos[dbalias][0]    = \"Whatever you want\";"
  echo "\$tutos[repository][0] = \"the path to the file/document repository\";"
  echo "----------------------------------------------------------------"
  echo ""
}

# EOF
